## mingw-w64-sse2neon-1.8.0-1.src.tar.zst

=== Makefile ===
ifndef CC
override CC = gcc
endif

ifndef CXX
override CXX = g++
endif

ifndef CROSS_COMPILE
    processor := $(shell uname -m)
else # CROSS_COMPILE was set
    CC = $(CROSS_COMPILE)gcc
    CXX = $(CROSS_COMPILE)g++
    CXXFLAGS += -static
    LDFLAGS += -static
    check_arm := $(shell echo | $(CROSS_COMPILE)cpp -dM - | grep " __ARM_ARCH " | cut -c20-)
    ifeq ($(check_arm),8)
        processor = aarch64
    else ifeq ($(check_arm),7) # detect ARMv7-A only
        processor = arm
    else
        $(error Unsupported cross-compiler)
    endif
endif

EXEC_WRAPPER =
ifdef CROSS_COMPILE
EXEC_WRAPPER = qemu-$(processor)
endif

# Follow platform-specific configurations
ARCH_CFLAGS ?=
ARCH_CFLAGS_IS_SET =
ifeq ($(ARCH_CFLAGS),)
    ARCH_CFLAGS_IS_SET = true
endif
ifeq ($(ARCH_CFLAGS),none)
    ARCH_CFLAGS_IS_SET = true
endif
ifdef ARCH_CFLAGS_IS_SET
    ifeq ($(processor),$(filter $(processor),aarch64 arm64))
        override ARCH_CFLAGS := -march=armv8-a+fp+simd
    else ifeq ($(processor),$(filter $(processor),i386 x86_64))
        override ARCH_CFLAGS := -maes -mpclmul -mssse3 -msse4.2
    else ifeq ($(processor),$(filter $(processor),arm armv7 armv7l))
        override ARCH_CFLAGS := -mfpu=neon
    else
        $(error Unsupported architecture)
    endif
endif

FEATURE ?=
ifneq ($(FEATURE),)
ifneq ($(FEATURE),none)
COMMA:= ,
ARCH_CFLAGS := $(ARCH_CFLAGS)+$(subst $(COMMA),+,$(FEATURE))
endif
endif

CXXFLAGS += -Wall -Wcast-qual -I. $(ARCH_CFLAGS) -std=gnu++14
LDFLAGS	+= -lm
OBJS = \
    tests/binding.o \
    tests/common.o \
    tests/impl.o \
    tests/main.o
deps := $(OBJS:%.o=%.o.d)

.SUFFIXES: .o .cpp
.cpp.o:
	$(CXX) -o $@ $(CXXFLAGS) -c -MMD -MF $@.d $<

EXEC = tests/main

$(EXEC): $(OBJS)
	$(CXX) $(LDFLAGS) -o $@ $^

check: tests/main
ifeq ($(processor),$(filter $(processor),aarch64 arm64 arm armv7l))
	$(CC) $(ARCH_CFLAGS) -c sse2neon.h
endif
	$(EXEC_WRAPPER) $^

indent:
	@echo "Formatting files with clang-format.."
	@if ! hash clang-format-18; then echo "clang-format-18 is required to indent"; fi
	clang-format-18 -i sse2neon.h tests/*.cpp tests/*.h

.PHONY: clean check format
clean:
	$(RM) $(OBJS) $(EXEC) $(deps) sse2neon.h.gch

-include $(deps)

=== PKGBUILD ===
# Maintainer: GH Cao

_realname=sse2neon
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.8.0
pkgrel=1
pkgdesc="sse2neon - A translator from Intel SSE intrinsics to Arm/Aarch64 NEON implementation (mingw-w64)"
arch=('any')
mingw_arch=('clangarm64')
url='https://github.com/DLTcollab/sse2neon'
license=('spdx:MIT')
source=("https://github.com/DLTcollab/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-Fix-mismatched-_mm_-malloc-free-with-LLVM-MinGW.patch::https://github.com/DLTcollab/sse2neon/commit/f30790d6.patch")
sha256sums=('e251746e3b761f3f0de1ad462b1efe53532341b6b0498d394765fceb85ce8a46'
            '9f689b7c57e67eed672cfe37ce222286d5dfaa9c4f70a22215b4a3ae68228f27')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-Fix-mismatched-_mm_-malloc-free-with-LLVM-MinGW.patch
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/sse2neon.h" \
    "${pkgdir}${MINGW_PREFIX}/include/${_realname}/sse2neon.h"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
